/**
 * Open SUIT - Simple User Interface Toolkit
 * 
 * Copyright (c) 2009 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.ow2.opensuit.cel;

import java.lang.reflect.Method;
import java.lang.reflect.Type;
import java.util.List;

public interface ICompilationContext
{
	Class getVariableType(String iName) throws UnresolvedVariableError;
	
	Type getVariableGenericType(String iName) throws UnresolvedVariableError;
	
	public static class UnresolvedVariableError extends Exception
	{
	}
	/**
	 * May return a compilable function
	 * @param prefix
	 * @param name
	 * @return
	 */
	List<IFunctionContext> getFunctions(String prefix, String name);
	
	// TODO: function methods
//	Class getFunctionType(String prefix, String name, IExpression[] arguments);
//	Type getFunctionGenericType(String prefix, String name, IExpression[] arguments);
	// + mthode pour compiler/valider les fonctions
//	void compileFunction(String prefix, String name, Method function, IExpression[] arguments, ICompilationLogger message);
	
	public static interface IFunctionContext
	{
		Method getMethod();
		
		void compile(List<IExpression> arguments, ICompilationLogger logger);
		
		String getValuePattern(List<IExpression> arguments);
	}
	public static interface ICompilationLogger
	{
		public final static int INFO_LEVEL = ICompilationMessage.INFO_LEVEL;
		public final static int WARNING_LEVEL = ICompilationMessage.WARNING_LEVEL;
		public final static int ERROR_LEVEL = ICompilationMessage.ERROR_LEVEL;

		void addMessage(int level, String message);
	}
}
