/*
 * Copyright 2006, 2007 Odysseus Software GmbH
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ow2.opensuit.cel.impl.tree;

import org.ow2.opensuit.cel.ICompilationContext;
import org.ow2.opensuit.cel.IExpression;
import org.ow2.opensuit.cel.ITypeConverter;
import org.ow2.opensuit.cel.impl.CompilationResult;


/**
 * Basic node interface.
 */
public interface IExprNode extends IExpression
{
//	public String getExpression();
	
	public int getPosition();

	public boolean compile(ITypeConverter converter, ICompilationContext context, CompilationResult results);
	
	/*
	public Object invoke(IEvaluationContext context) throws ExpressionEvaluationException;
	public void set(IEvaluationContext context, Object value) throws ExpressionEvaluationException;
	*/
}
