package org.ow2.opensuit.cel.impl.tree.impl.ast;

import org.ow2.opensuit.cel.impl.tree.IExprNode;

public abstract class AstNode implements IExprNode
{
	protected int position;

	public AstNode(int position)
	{
		this.position = position;
	}

	public final String getExpressionString()
	{
		StringBuilder builder = new StringBuilder();
		appendExpressionString(builder);
		return builder.toString();
	}

	protected abstract void appendExpressionString(StringBuilder builder);

	public final String getValuePattern()
	{
		StringBuilder builder = new StringBuilder();
		appendValuePattern(builder);
		return builder.toString();
	}

	protected abstract void appendValuePattern(StringBuilder builder);

	/*
	 * protected final void appendValuePattern(StringBuilder builder) {
	 * if(isStaticValue()) RegExpBuilder.appendString(builder,
	 * String.valueOf(invoke(null))); else RegExpBuilder.appendTypeExpr(builder,
	 * getGenericType()); }
	 */

	@Override
	public final String toString()
	{
		return getExpressionString();
	}

	public final int getPosition()
	{
		return position;
	}
}
